# Building

1. Download the boost framework http://www.boost.org/users/download/
2. Set environment variable `BOOST_ROOT` to the boost root directory
3. Since I don't know how to run cmake, either you figure it out or simply run it with CLion :P.    

# Documentation

An example scenario.

Here we suppose to run a platoon as leader:

```cpp
// Create a networking thread.
// All logic is executed asynchronously on this single thread.
networking::Networking net;
// Create a leader.
auto leader = protocol::LeaderVehicle::create(net, 1);  // 1 = vehicleId
// Set the initial platoon configuration.
// This can be set at anytime and will be send to the following vehicles.
leader->setPlatoonConfig(protocol::PlatoonConfig{10.0f, 20.0f});
// Start the platoon.
leader->createPlatoon();
// Do something different...
// ...
// Decide to leave the platoon.
leader->leavePlatoon();
```

And on another machine, we're running a follower:

```cpp
// Create a networking thread.
// All logic is executed asynchronously on this single thread.
networking::Networking net;
// Create a leader.
auto follower = protocol::FollowerVehicle::create(net, 2);  // 2 = vehicleId
// Register a callback to receive platoon configuration updates (ps and ipd).
follower->setOnUpdatePlatoonConfigCallback(
    [](const protocol::PlatoonConfig & config){/* Received updated platoonConfig. */});
// Start the platoon.
follower->createPlatoon();
// Do something different...
// ...
// Decide to leave the platoon.
follower->leavePlatoon();
```